#pragma once

namespace GDIView
{

class Canvas
{
public:

	Canvas(const int aWidth, const int aHeight, const unsigned int aColor)
	:myCanvas(aWidth, aHeight)
	{
		Gdiplus::Color c(aColor);
		Gdiplus::SolidBrush b(c);

		myGraphics = Gdiplus::Graphics::FromImage(&myCanvas);
		myGraphics->FillRectangle(&b, 0, 0, aWidth, aHeight);
	}

	~Canvas()
	{
		delete myGraphics;
	}

	Gdiplus::Graphics& getGraphics()
	{
		return *myGraphics;
	}

	void render(Gdiplus::Graphics& aTarget)
	{
		aTarget.DrawImage(&myCanvas, 0, 0);
	}

private:

	//members
	Gdiplus::Bitmap myCanvas;
	Gdiplus::Graphics* myGraphics;
};

}