#pragma once

#include "scalar.h"

namespace GDIView
{

struct Style;

class Rect
{
public:

	static void gradient(Gdiplus::Graphics& someGraphics, const Style& aStyle, const int aX, const int aY, const int aWidth, const int aHeight);
	static const bool inside(const POINT& aPoint, const int anOriginX, const int anOriginY, const int aX, const int aY, const int aWidth, const int aHeight);
	Rect();
	void set(const bool aDown, const Style& aStyle, const int aX, const int aY, const int aWidth, const int aHeight);
	void render(Gdiplus::Graphics& aGraphics, const int anOriginX, const int anOriginY);
	const bool inside(const POINT& aPoint, const int anOriginX, const int anOriginY, const bool aSet);

private:

	//members
	bool myInside, myDown;
	const Style* myStyle;
	Scalar myX, myY, myWidth, myHeight;
	Gdiplus::Color myColor;
};

}