#include "stdafx.h"
#include "scalar.h"

#include "time.h"

namespace GDIView
{

#define SPEED 20.f

Scalar::Scalar()
:myCurrent(0.f)
,myTarget(0.f)
{
}

void Scalar::lerp()
{
	const float DIFF(myTarget - myCurrent);

	if(DIFF < 1.f)
		myCurrent = myTarget;
	else
		myCurrent += DIFF * Time::elapsed() * SPEED;
}

void Scalar::set(const int aValue)
{
	myTarget = (float)aValue;
}

const int Scalar::get() const
{
	//return (int)myCurrent;
	return (int)myTarget;
}

}