#pragma once

#include "keystate.h"
#include "text.h"
#include "rect.h"

namespace GDIView
{

class Window;

class State
{
public:

	State(const int aButtonWidth, const int aButtonHeight);
	void beginDrag(const int aScreenX, const int aScreenY, const Style& aStyle, const int aWidth, const int aHeight, const WCHAR* aText);
	void doDrag(const Style& aStyle, const int aWidth, const int aHeight, const WCHAR* aText);
	void update();
	void render(Gdiplus::Graphics& someGraphics);
	const float scrollX();
	const float scrollY();
	const bool isDown(const int aKey) const;
	const bool wasPressed(const int aKey) const;
	const POINT cursorPos() const;
	const POINT dragPos() const;
	const void* dropOutside(const int aX, const int aY, const int aWidth, const int aHeight) const;

	//members
	const int myButtonWidth, myButtonHeight;
	const void* myDrag, *myDrop;
	float* myScroll;
	HWND myWindow;
	bool myInsideRect;

private:

	enum
	{
		NUM_KEYSTATES = 256,
	};

	//members
	Text myDragText;
	Rect myDragRect;
	POINT myDragPos;
	int myScrollPos;
	KeyState myKeyStates[NUM_KEYSTATES];
};

}