#include "stdafx.h"
#include "text.h"

namespace GDIView
{

void Text::render(Gdiplus::Graphics& someGraphics, const unsigned int aColor, const int aX, const int aY, const WCHAR* aText)
{
	Gdiplus::FontFamily fam(L"Verdana");
	Gdiplus::Font f(&fam, Text::FONT_SIZE, Gdiplus::FontStyleBold, Gdiplus::UnitPixel);
	Gdiplus::PointF p((float)aX, (float)aY);
	Gdiplus::Color c(aColor);
	Gdiplus::SolidBrush b(c);

	someGraphics.DrawString(aText, -1, &f, p, &b);
}

Text::Text()
:myX(0)
,myY(0)
{
}

void Text::set(const int aX, const int aY, const WCHAR* aText, const unsigned int aColor)
{
	myX = aX;
	myY = aY;
	myText = aText;
	myColor = aColor;
}

void Text::render(Gdiplus::Graphics& someGraphics, const int anOriginX, const int anOriginY) const
{
	render(someGraphics, myColor, myX + anOriginX, myY + anOriginY, myText);

}

}