#pragma once

#include "state.h"
#include "windows.h"

namespace GDIView
{

class View
{
public:

	View(const int aButtonWidth, const int aButtonHeight);
	void init(HINSTANCE hInstance, INT iCmdShow, const int aWidth, const int aHeight, const WCHAR* aTitle);
	void cleanup();
	Window* window(const WCHAR* aTitle, const int aX, const int aY, const int aWidth, const int aHeight);
	void draw();

private:

	void render(Gdiplus::Graphics& aGraphics);

	//members
	State myState;
	Windows myWindows;

	//for render call
	friend LRESULT CALLBACK wndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
};

}