#pragma once

#include "model.h"

namespace GDIView
{
	class Window;
}

namespace GuiTest
{

class IEventTarget;
class Model;

class IController
{
public:

	virtual void doControl(IEventTarget& aTarget) = 0;

protected:

	IController(const Model& aModel, GDIView::Window& aWindow);
	const unsigned int itemIndex(const void* anItem) const;

	//members
	static const WCHAR* ITEM_NAMES[Model::NUM_ITEMS];
	const Model& myModel;
	GDIView::Window& myWindow;
};

}