#include "stdafx.h"
#include "model.h"

namespace GuiTest
{

//IEventTarget implementation
void Model::addToInventory(const unsigned int anIndex, const unsigned int aSlot)
{
	if(anIndex < NUM_ITEMS && slotFree(true, aSlot))
	{
		myItems[anIndex].myInventory = true;
		myItems[anIndex].mySlot = aSlot;
	}
}

void Model::removeFromInventory(const unsigned int anIndex, const unsigned int aSlot)
{
	if(anIndex < NUM_ITEMS && slotFree(false, aSlot))
	{
		myItems[anIndex].myInventory = false;
		myItems[anIndex].mySlot = aSlot;
	}
}

void Model::toggleGoodLike(const unsigned int aGood)
{
	if(aGood < NUM_GOODS)
		myGoods[aGood].myLike = !myGoods[aGood].myLike;
}

//specific interface
Model::Model()
{
	unsigned int i;

	for(i = 0; i < NUM_ITEMS; i++)
		myItems[i].mySlot = i;

	myGoods[0].set(fruit,	L"Apple", L"Tastyness!");
	myGoods[1].set(fruit,	L"Orange", L"Nice color!");
	myGoods[2].set(veggies,	L"Cucumber", L"Green!");
	myGoods[3].set(veggies,	L"Tomato", L"Red!");
	myGoods[4].set(meat,	L"Horse", L"Cowboy!");
	myGoods[5].set(meat,	L"Pig", L"Pinky!");
	myGoods[6].set(poultry,	L"Egg", L"Round!");
	myGoods[7].set(poultry,	L"Turkey", L"Grill!");
	myGoods[8].set(dairy,	L"Milk", L"White!");
	myGoods[9].set(dairy,	L"Yoghurt", L"Smooth!");
}

//private
const bool Model::slotFree(const bool anInventory, const unsigned int aSlot) const
{
	unsigned int i;

	for(i = 0; i < NUM_ITEMS; i++)
	{
		if(myItems[i].myInventory == anInventory && myItems[i].mySlot == aSlot)
			return false;
	}

	return true;
}

}