#pragma once

#include "ieventtarget.h"

namespace GuiTest
{

class Model : public IEventTarget
{
public:

	//IEventTarget implementation
	void addToInventory(const unsigned int anIndex, const unsigned int aSlot);
	void removeFromInventory(const unsigned int anIndex, const unsigned int aSlot);
	void toggleGoodLike(const unsigned int aGood);

	//specific interface
	Model();

	struct Item
	{
		Item()
		:myInventory(false)
		,mySlot(0)
		{
		}

		//members
		bool myInventory;
		unsigned int mySlot;
	};

	struct Good
	{
		void set(const unsigned char aCategory, const WCHAR* aName, const WCHAR* aDescription)
		{
			myCategory = aCategory;
			myName = aName;
			myDescription = aDescription;
			myLike = false;
		}

		//members
		unsigned char myCategory;
		const WCHAR* myName, *myDescription;
		bool myLike;
	};

	enum
	{
		NUM_ITEMS = 3,
		NUM_GOODS = 10,
	};

	enum Category
	{
		fruit,
		veggies,
		meat,
		poultry,
		dairy,
		NUM_CATEGORIES,
	};

	//members
	Item myItems[NUM_ITEMS];
	Good myGoods[NUM_GOODS];

private:

	const bool slotFree(const bool anInventory, const unsigned int aSlot) const;
};

}