#include "stdafx.h"
#include "othercontroller.h"

#include "../gdiview/window.h"

namespace GuiTest
{

//IController
void OtherController::doControl(IEventTarget& aTarget)
{
	const int SLOT(5), INV(64), SPACE(INV), ITEM(48), OFFSET((INV - ITEM) / 2);
	const int X(64), Y(64 + 128);
	const void* d;
	unsigned int i;

	myWindow.frame();

	//drops
	myWindow.text(X, Y - myWindow.buttonHeight(), L"Ground", -1);
	for(i = 0; i < SLOT; i++)
	{
		d = myWindow.drop(X + i * INV, Y, INV, INV);
		if(d)
			aTarget.removeFromInventory(itemIndex(d), i);
	}

	//drags
	for(i = 0; i < Model::NUM_ITEMS; i++)
	{
		const Model::Item* item(myModel.myItems + i);
		if(!item->myInventory)
			myWindow.drag(item, item->mySlot * SPACE + X + OFFSET, Y + OFFSET, ITEM, ITEM, ITEM_NAMES[i]);
	}
}

//specific interface
OtherController::OtherController(const Model& aModel, GDIView::Window& aWindow)
:IController(aModel, aWindow)
{
}

}