#include "stdafx.h"

#include "../gdiview/time.h"
#include "../gdiview/view.h"
#include "../gdiview/window.h"
#include "testcontroller.h"
#include "othercontroller.h"
#include "yetanothercontroller.h"
#include "model.h"

INT WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, PSTR, INT iCmdShow)
{
	MSG msg;

	//domain model
	GuiTest::Model m;

	//view
	GDIView::View v(96, 16);

	//controllers
	//NOTE: the window() call can fail (there is a hard-coded limit to the number of windows supported)
	//so you probably wouldn't want to do this in a production environment :P
	GuiTest::TestController c1(m, *v.window(L"TestController", 0, 0, 512, 400));
	GuiTest::OtherController c2(m, *v.window(L"OtherController", 520, 0, 512, 400));
	GuiTest::YetAnotherController c3(m, *v.window(L"YetAnotherController", 256, 420, 512, 200));

	//window, GDI+ startup, etc...
	v.init(hInstance, iCmdShow, CW_USEDEFAULT, CW_USEDEFAULT, L"IMGUI implemented with GDI+");

	while(1)
	{
		if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if(!GetMessage(&msg, NULL, 0, 0 ))
				break;

			TranslateMessage(&msg); 
			DispatchMessage(&msg);
		}
		else
		{
			GDIView::Time::update();

			//controllers
			c1.doControl(m);
			c2.doControl(m);
			c3.doControl(m);

			//render view
			v.draw();

			//arbitrary, so we don't eat all cpu time
//			Sleep(10);
		}
	}

	v.cleanup();

	return (int)msg.wParam;
}
